package client;
/**
 * 
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.Socket;

import java.io.IOException;

/**
 * @author Daniel Castonguay
 *
 */
public class ThreadReceptionMessagesClient implements Runnable 
{
	private Client client = null;
	private Socket socket = null; 
	
	public ThreadReceptionMessagesClient(Client c, Socket s)
	{
		client = c;
		socket = s;
	}
	
	public void run()
	{
		BufferedReader fluxEntrant = null;
		
		try
		{
			// Le flux sera ferm par la fermeture du socket; rien  grer.
			fluxEntrant = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			boolean connexionInterrompue = false;
			
			while (!connexionInterrompue && socket.isConnected() && !socket.isClosed() && !socket.isInputShutdown())
			{
				String ligneLue = fluxEntrant.readLine();
				
				if (ligneLue != null)
					client.messageRecu(ligneLue);
				else
				{
					// End-Of-Stream: le serveur a ferm la connexion
					connexionInterrompue = true;
					client.connexionInterrompue();
				}
			}
		}
		catch (IOException ioe)
		{
			if (!client.enDeconnexion())
				client.exceptionRecue(ioe);
		}
	}

}
