/**
 * 
 */
package client.ecouteur;

/**
 * @author Daniel Castonguay
 *
 */
public class EcouteurSimple implements IEcouteur 
{
	public void afficherErreur(Exception exception) 
	{
		System.err.println("Erreur: " + exception.getMessage());
		System.err.println("Connexion invalide; les prochaines commandes choueront.");
	}

	public void authentificationReussie(String alias)
	{
		System.out.println("Authentification reussie. Alias: " + alias);
	}
	
	public void authentificationEchouee()
	{
		System.out.println("Authentification echouee.");
	}
	
	public void authentificationDejaEffectuee()
	{
		System.out.println("Authentification deja effectuee.");
	}
	
	public void canalJoint(String canal, String[] participants)
	{
		System.out.format("Vous avez joint le canal %s.\n", canal);
	}
	
	public void canalNonJoint(String canal, String message)
	{
		System.out.format("Vous n'avez pas joint %s%s\n", canal, (message.isEmpty() ? "." : ": " + message));
	}
	
	public void canalQuitte(String canal)
	{
		System.out.format("Vous avez quitte %s.\n", canal);
	}
	
	public void canalNonQuitte(String canal, String message)
	{
		System.out.format("Vous n'avez pas quitte %s%s\n", canal, (message.isEmpty() ? "." : ": " + message ));
	}
	
	public void aliasChange(String alias)
	{
		System.out.format("Vous avez change votre alias pour \"%s\".\n", alias);
	}
	
	public void aliasInvalide(String alias)
	{
		System.out.format("L'alias \"%s\" est invalide.", alias);
	}
	
	public void aliasDejaUtilise(String alias)
	{
		System.out.format("L'alias \"%s\" est deja utilise.\n", alias);
	}
	
	public void messageCanalNonEnvoye(String canal, String message)
	{
		System.out.format("Le message n'a pas ete envoye au canal %s%s\n", canal, (message.isEmpty() ? "." : ": " + message));
	}
	
	public void messageUsagerNonEnvoye(String usager, String message)
	{
		System.out.format("Le message n'a pas ete envoye a l'usager %s%s\n", usager, (message.isEmpty() ? "." : ": " + message));
	}
	
	public void aliasNonTrouve(String alias)
	{
		System.out.format("L'alias \"%s\" n'a pas ete trouve.\n", alias);
	}

	public void canalNonTrouve(String canal)
	{
		System.out.format("Le canal %s n'a pas ete trouve.\n", canal);
	}

	public void informationCanal(String canal, String[] participants)
	{
		StringBuilder sb = new StringBuilder(participants[0]);
		
		for (int i = 1; i < participants.length; i++)
			sb.append(", " + participants[i]);
		
		System.out.format("Le canal %s heberge: %s\n", canal, sb.toString());
	}

	public void informationUsager(String usager, String alias, String[] canaux) 
	{
		StringBuilder sb = null;
		
		if (canaux != null && canaux.length > 0)
		{
			sb = new StringBuilder(canaux[0]);
			
			for (int i = 1; i < canaux.length; i++)
				sb.append(", " + canaux[i]);
		}
		
		System.out.format("L'usager \"%s\" (alias: \"%s\")%s\n", 
						  usager, 
						  alias, 
						  (sb == null ? " n'est sur aucun canal." : " est sur " + sb.toString() + "."));
	}

	public void nonAuthentifie()
	{
		System.out.println("Vous n'etes pas authentifie.");
	}
	
	public void evenementMessage(String canal, String usager, String message)
	{
		System.out.format("%s: %s> %s\n", canal, usager, message);
	}
	
	public void evenementMessage(String usager, String message)
	{
		System.out.format("%s> %s\n", usager, message);
	}
	
	public void evenementCanalJoint(String canal, String usager)
	{
		System.out.format("%s a joint le canal %s.\n", usager, canal);
	}
	
	public void evenementCanalQuitte(String canal, String usager, String message)
	{
		System.out.format("%s a quitte le canal %s%s\n", usager, canal, (message.isEmpty() ? "." : ": " + message));
	}
	
	public void evenementAliasModifie(String vieilAlias, String nouvelAlias)
	{
		System.out.format("%s a change son alias pour %s.\n", vieilAlias, nouvelAlias);
	}
	
	public void evenementQuitte(String usager, String message)
	{
		System.out.format("%s a quitte le reseau%s\n", usager, (message.isEmpty() ? "." : ": " + message));
	}
	
	
	public void evenementDelaiDepasse()
	{
		System.out.println("Vous etes deconnecte car le delai d'inactivite est depasse.");
	}
	
	public void evenementDeconnecte(String message)
	{
		if (message == null || message.isEmpty())
			System.out.println("Vous avez ete deconnecte pour une raison inconnue.");
		else
			System.out.println("Vous avez ete deconnecte: " + message);
	}
	
	public void evenementCommandeErronee()
	{
		System.out.println("Vous avez envoye une commande erronee.");
	}
	
	public void connexionInterrompue()
	{
		System.out.println("La connexion a ete interrompue.");
	}
	
	
	public void reponseNonReconnue(String reponse)
	{
		System.out.println("Reponse du serveur non reconnue: " + reponse);
	}
	
	public void afficherReponseBrute(String reponse)
	{
		// Ne rien faire.
	}
}
