package commun;

import java.util.regex.Pattern;

public class Constantes {

	public static final String LINE_SEPARATOR = System.getProperty("line.separator"); 
	
	//////////////////////////////////////
	// Constantes du protocole (termes) //
	//////////////////////////////////////
	
	// Commandes client
	public static final String LOGIN = "LOGIN";
	public static final String JOIN = "JOIN";
	public static final String PART = "PART";
	public static final String WHOIS = "WHOIS";
	public static final String WHOISON = "WHOISON";
	public static final String ALIAS = "ALIAS";
	public static final String MSG = "MSG";
	public static final String QUIT = "QUIT";
	public static final String NOOP = "NOOP";
	
	// Rponses aux commandes
	public static final String COMMAND_ERROR = "COMMAND_ERROR";
	public static final String NOT_LOGGED_IN = "NOT_LOGGED_IN";
	public static final String ALREADY_LOGGED_IN = "ALREADY_LOGGED_IN";
	public static final String LOGGED_IN = "LOGGED_IN";
	public static final String LOGIN_INVALID = "LOGIN_INVALID";
	public static final String JOINED = "JOINED";
	public static final String JOIN_REFUSED = "JOIN_REFUSED";
	public static final String PARTED = "PARTED";
	public static final String PARTED_ERROR = "PARTED_ERROR";
	public static final String USERS_ON = "USERS_ON";
	public static final String CHANNEL_NOT_FOUND = "CHANNEL_NOT_FOUND";
	public static final String USER = "USER";
	public static final String ALIAS_NOT_FOUND = "ALIAS_NOT_FOUND";
	public static final String ALIAS_INVALID = "ALIAS_INVALID";
	public static final String ALIAS_CHANGED = "ALIAS_CHANGED";
	public static final String ALIAS_ALREADY_USED = "ALIAS_ALREADY_USED";
	public static final String MSG_NOT_SENT = "MSG_NOT_SENT";

	// vnements
	public static final String EVENT = "EVENT";
	// MSG, JOIN, PART, ALIAS & QUIT dj dfinis
	public static final String TIMEOUT = "TIMEOUT";
	public static final String LOGGED_OUT = "LOGGED_OUT";
	public static final String DISCONNECTED = "DISCONNECTED"; // Dconnect pour autre chose qu'un timeout

	/////////////////////////
	// Commandes possibles //
	/////////////////////////
	public static final String MATCH_LOGIN = String.format("^(%s)\\s+(\\w+)(\\s+(\\S+))?$", LOGIN);
	public static final String MATCH_JOIN = String.format("^(%s)\\s+(#\\w+)$", JOIN);
	public static final String MATCH_PART = String.format("^(%s)\\s+(#\\w+)(\\s+(.+))?$", PART);
	public static final String MATCH_ALIAS = String.format("^(%s)\\s+(\\w+)$", ALIAS);
	public static final String MATCH_MSG_ALIAS = String.format("^(%s)\\s+(\\w+)\\s+(.+)$", MSG);
	public static final String MATCH_MSG_CANAL = String.format("^(%s)\\s+(#\\w+)\\s+(.+)$", MSG);
	public static final String MATCH_WHOIS = String.format("^(%s)\\s+(\\w+)$", WHOIS);
	public static final String MATCH_WHOISON = String.format("^(%s)\\s+(#\\w+)$", WHOISON);
	public static final String MATCH_QUIT = String.format("^(%s)(\\s+(.+))?$", QUIT);
	public static final String MATCH_NOOP = String.format("^(%s)$", NOOP);
	
	///////////////////////////////////////////////////////
	// Rponses possibles aux commandes et notifications //
	///////////////////////////////////////////////////////
	public static final String MATCH_LOGGED_IN = String.format("^(%s)\\s+(\\w+)$", LOGGED_IN);
	public static final String MATCH_LOGIN_INVALID = String.format("^(%s)$", LOGIN_INVALID);
	public static final String MATCH_ALREADY_LOGGED_IN = String.format("^(%s)$", ALREADY_LOGGED_IN);
	public static final String MATCH_JOINED = String.format("^(%s)\\s+(#\\w+)\\s+((\\w+ ?)+)$", JOINED);
	public static final String MATCH_JOIN_REFUSED = String.format("^(%s)\\s+(#\\w+)(\\s(.+))?$", JOIN_REFUSED);
	public static final String MATCH_PARTED = String.format("^(%s)\\s+(#\\w+)$", PARTED);
	public static final String MATCH_PARTED_ERROR = String.format("^(%s)\\s+(#\\w+)(\\s(.+))?$", PARTED_ERROR);
	public static final String MATCH_ALIAS_CHANGED = String.format("^(%s)\\s+(\\w+)$", ALIAS_CHANGED);
	public static final String MATCH_ALIAS_INVALID = String.format("^(%s)\\s+(\\w+)$", ALIAS_INVALID);
	public static final String MATCH_ALIAS_ALREADY_USED = String.format("^(%s)\\s+(\\w+)$", ALIAS_ALREADY_USED);
	public static final String MATCH_MSG_NOT_SENT_CANAL = String.format("^(%s)\\s+(#\\w+)(\\s(.+))?$", MSG_NOT_SENT);
	public static final String MATCH_MSG_NOT_SENT_ALIAS = String.format("^(%s)\\s+(\\w+)(\\s(.+))?$", MSG_NOT_SENT);
	public static final String MATCH_USER = String.format("^(%s)\\s+(\\w+)\\s+(\\w+)\\s+((#\\w+ )*)$", USER);
	public static final String MATCH_ALIAS_NOT_FOUND = String.format("^(%s)\\s+(\\w+)$", ALIAS_NOT_FOUND);
	public static final String MATCH_USERS_ON = String.format("^(%s)\\s+(#\\w+)\\s+((\\w+ ?)+)$", USERS_ON);
	public static final String MATCH_CHANNEL_NOT_FOUND = String.format("^(%s)\\s+(#\\w+)$", CHANNEL_NOT_FOUND);
	public static final String MATCH_NOT_LOGGED_IN = String.format("^(%s)$", NOT_LOGGED_IN);
	
	// Notifications envoyes  tout le monde
	public static final String MATCH_EVENT_MSG_ALIAS = String.format("^(%s)\\s+(%s)\\s+(\\w+)\\s(.+)$", EVENT, MSG);
	public static final String MATCH_EVENT_MSG_CANAL = String.format("^(%s)\\s+(%s)\\s+(#\\w+)\\s+(\\w+)\\s(.+)$", EVENT, MSG);
	public static final String MATCH_EVENT_JOIN = String.format("^(%s)\\s+(%s)\\s+(#\\w+)\\s+(\\w+)$", EVENT, JOIN);
	public static final String MATCH_EVENT_PART = String.format("^(%s)\\s+(%s)\\s+(#\\w+)\\s+(\\w+)(\\s(.+))?$", EVENT, PART);
	public static final String MATCH_EVENT_ALIAS = String.format("^(%s)\\s+(%s)\\s+(\\w+)\\s+(\\w+)$", EVENT, ALIAS);
	public static final String MATCH_EVENT_QUIT = String.format("^(%s)\\s+(%s)\\s+(\\w+)(\\s(.+))?$", EVENT, QUIT);
	
	// Notifications prives
	public static final String MATCH_EVENT_TIMEOUT = String.format("^(%s)\\s+(%s)$", EVENT, TIMEOUT);
	public static final String MATCH_EVENT_LOGGED_OUT = String.format("^(%s)\\s+(%s)$", EVENT, LOGGED_OUT);
	public static final String MATCH_EVENT_DISCONNECTED = String.format("^(%s)\\s+(%s)(\\s(.+))?$", EVENT, DISCONNECTED);
	public static final String MATCH_EVENT_COMMAND_ERROR = String.format("^(%s)\\s+(%s)$", EVENT, COMMAND_ERROR);
	
	//////////////////////////
	// Patterns prcompils //
	//////////////////////////
	public static final Pattern PATTERN_LOGIN = Pattern.compile(MATCH_LOGIN);
	public static final Pattern PATTERN_JOIN = Pattern.compile(MATCH_JOIN);
	public static final Pattern PATTERN_PART = Pattern.compile(MATCH_PART);
	public static final Pattern PATTERN_ALIAS = Pattern.compile(MATCH_ALIAS);
	public static final Pattern PATTERN_MSG_ALIAS = Pattern.compile(MATCH_MSG_ALIAS);
	public static final Pattern PATTERN_MSG_CANAL = Pattern.compile(MATCH_MSG_CANAL);
	public static final Pattern PATTERN_WHOIS = Pattern.compile(MATCH_WHOIS);
	public static final Pattern PATTERN_WHOISON = Pattern.compile(MATCH_WHOISON);
	public static final Pattern PATTERN_QUIT = Pattern.compile(MATCH_QUIT);
	public static final Pattern PATTERN_NOOP = Pattern.compile(MATCH_NOOP);	
	
	public static final Pattern PATTERN_LOGGED_IN = Pattern.compile(MATCH_LOGGED_IN);
	public static final Pattern PATTERN_LOGIN_INVALID = Pattern.compile(MATCH_LOGIN_INVALID);
	public static final Pattern PATTERN_ALREADY_LOGGED_IN = Pattern.compile(MATCH_ALREADY_LOGGED_IN);
	public static final Pattern PATTERN_JOINED = Pattern.compile(MATCH_JOINED);
	public static final Pattern PATTERN_JOIN_REFUSED = Pattern.compile(MATCH_JOIN_REFUSED);
	public static final Pattern PATTERN_PARTED = Pattern.compile(MATCH_PARTED);
	public static final Pattern PATTERN_PARTED_ERROR = Pattern.compile(MATCH_PARTED_ERROR);
	public static final Pattern PATTERN_ALIAS_CHANGED = Pattern.compile(MATCH_ALIAS_CHANGED);
	public static final Pattern PATTERN_ALIAS_INVALID = Pattern.compile(MATCH_ALIAS_INVALID);
	public static final Pattern PATTERN_ALIAS_ALREADY_USED = Pattern.compile(MATCH_ALIAS_ALREADY_USED);
	public static final Pattern PATTERN_MSG_NOT_SENT_CANAL = Pattern.compile(MATCH_MSG_NOT_SENT_CANAL);
	public static final Pattern PATTERN_MSG_NOT_SENT_ALIAS = Pattern.compile(MATCH_MSG_NOT_SENT_ALIAS);
	public static final Pattern PATTERN_USER = Pattern.compile(MATCH_USER);
	public static final Pattern PATTERN_ALIAS_NOT_FOUND = Pattern.compile(MATCH_ALIAS_NOT_FOUND);
	public static final Pattern PATTERN_USERS_ON = Pattern.compile(MATCH_USERS_ON);
	public static final Pattern PATTERN_CHANNEL_NOT_FOUND = Pattern.compile(MATCH_CHANNEL_NOT_FOUND);
	public static final Pattern PATTERN_NOT_LOGGED_IN = Pattern.compile(MATCH_NOT_LOGGED_IN);
	
	public static final Pattern PATTERN_EVENT_MSG_ALIAS = Pattern.compile(MATCH_EVENT_MSG_ALIAS);
	public static final Pattern PATTERN_EVENT_MSG_CANAL = Pattern.compile(MATCH_EVENT_MSG_CANAL);
	public static final Pattern PATTERN_EVENT_JOIN = Pattern.compile(MATCH_EVENT_JOIN);
	public static final Pattern PATTERN_EVENT_PART = Pattern.compile(MATCH_EVENT_PART);
	public static final Pattern PATTERN_EVENT_ALIAS = Pattern.compile(MATCH_EVENT_ALIAS);
	public static final Pattern PATTERN_EVENT_QUIT = Pattern.compile(MATCH_EVENT_QUIT);
	
	public static final Pattern PATTERN_EVENT_TIMEOUT = Pattern.compile(MATCH_EVENT_TIMEOUT);
	public static final Pattern PATTERN_EVENT_LOGGED_OUT = Pattern.compile(MATCH_EVENT_LOGGED_OUT);
	public static final Pattern PATTERN_EVENT_DISCONNECTED = Pattern.compile(MATCH_EVENT_DISCONNECTED);
	public static final Pattern PATTERN_EVENT_COMMAND_ERROR = Pattern.compile(MATCH_EVENT_COMMAND_ERROR);
	
	
	// Constantes utiles
	//
	public static final int PORT_PAR_DEFAUT = 0xBABE;
	public static final int LIMITE_TEMPORISATEUR = 30000; // Millisecondes
	
}
